unit hiStringTable; {  ver 4.70 MT}

interface

uses Windows,Messages,Share,Win,Debug,ListEdit,Kol,ShellAPI;

const
   LOAD_TABLE         =  0 ;
   LOAD_ICON          =  2 ;
   LOAD_PAK_ICONS     =  4 ;
   LOAD_ILIST         =  5 ;
   LOAD_EXTICON       =  7 ;
   LOAD_STRING_LIST   =  10;
   LOAD_FSTREAM       =  13;

   SAVE_TABLE         =  1 ;
   SAVE_ICON_FILE     =  3 ;
   SAVE_ILIST         =  6 ;
   SAVE_STRING_LIST   =  8 ;
   APPEND_STRING_FILE =  9 ;
   SAVE_FSTREAM       =  14;

   SKIP               =  -1;

   ITM_ADD            =  -3;
   ITM_INSERT         =  -4;
   ITM_REPLACE        =  -5;

   EMATRIX            =  -6;
   CHK_EMATRIX        =  -7;
   SEL_EMATRIX        =  -8;

   COL_NAME           =  -9;
   COL_WIDTH          = -10;
   COL_IMAGE          = -11;
   COL_ALIGN          = -12;

   AColor: array [0..15] of TColor =
		   (clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
		   clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite);
   
type
  ThiStringTable = class(THIWin)
   private
    ComboItem, ComboCol, ComboTopItem:integer;
    ComboBox:PControl;
    _FlagCombo:boolean;
    _FlagRedraw:boolean;
    indent:integer;
    SortCol:integer;
    Icon:PIcon;
    Obj:PMatrix;   
    Arr,CBArray,SAArray,CLArray,ICArray,SLArray:PArray;
    IDList:PStrListEx;
    IList,IChList:PImageList;
    CList,FList:PStrList;
    _StrDlm:char;
    _ColorDlm:char;
    _MTColDlm:char;
    LoadStream, LICLStream, LTblStream:PStream;
    SICLStream, STblStream, FTblStream:PStream;

    function GetSmallIcon(Path: String; IconIndex: Integer): hIcon;
    procedure _onComboClick (Obj:PObj);
    procedure SetIListProp();
    procedure SetIcons(const value:PStrListEx);
    procedure SetIconsCheck(const value:PStrListEx);
    procedure SetMiscIcons(const value:PStrListEx);
    procedure SaveIListToFile(const FileName:string; Index:word);
    procedure LoadIListFromFile(const FileName:string; Index:word);
    procedure SetColumns(const ListCol:PStrList; Mode:integer);
    function _OnCmpText( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    function _OnCmpReal( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    function _OnCmpExt( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    procedure _OnColumnClick( ender: PControl; Idx: Integer);
    procedure _OnBeforeLineChange(Sender: PControl; Idx: Integer);
    procedure _OnLineChange(Sender: PControl; Idx: Integer);
    function  _OnLVCustomDraw(Sender: PControl; DC: HDC; Stage: DWORD;
                  ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                  ItemState: TDrawState; var TextColor, BackColor: TColor): DWORD;
    procedure Add(const Data:string; Index:integer = -1; _Replace:boolean = false);
    procedure MX_Set(x,y:integer; var Val:TData);
    function MX_Get(x,y:integer):TData;
    procedure CB_Set(var Item:TData; var Val:TData);
    function CB_Get(Var Item:TData; var Val:TData):boolean;
    procedure SA_Set(var Item:TData; var Val:TData);
    function SA_Get(Var Item:TData; var Val:TData):boolean;
    function SACB_Count:integer;
    procedure _SetIcon(var Item:TData; var Val:TData);
    function _GetIcon(Var Item:TData; var Val:TData):boolean;
    procedure _AddIcon(var Val:TData);
    function  _CountIcon:integer;
    function InitColStr(var Val:string):string;
    procedure InsertIcon(Data:TData; Index:word);
    procedure _SetCol(var Item:TData; var Val:TData);
    function _GetCol(Var Item:TData; var Val:TData):boolean;
    procedure _AddCol(var Val:TData);
    function _CountCol:integer;
    procedure ClearIcons();
    procedure SetTextStrLst(const Value:string);
    procedure SetTextColLst(const Value:string);
    procedure _SetStrLst(var Item:TData; var Val:TData);
    function _GetStrLst(Var Item:TData; var Val:TData):boolean;
    function _CountStrLst:integer;
    procedure _AddStrLst(var Val:TData);
    function Get(index:integer):string;
    procedure _aSet(var Item:TData; var Val:TData);
    function _aGet(Var Item:TData; var Val:TData):boolean;
    function _aCount:integer;
    procedure _aAdd(var Val:TData);
    function PakColor2Str(data:dword):string;
    procedure SetOption(OSet:boolean; Option:TListViewOption); 

    procedure _OnSelState( Sender: PControl; IdxFrom, IdxTo: Integer; OldState, NewState: cardinal );
    function LFileExists_MT(FileName:string;FileOperation:integer):boolean;
    function SFileExists_MT(FileName:string;FileOperation:integer):boolean;

    procedure MT_ActionItm(var Data:TData; Mode:integer);
    procedure MT_ActionCol(var Data:TData; Mode:integer);
    procedure MT_ProperCol(var Data:TData; Mode:integer);
    procedure MT_ActionIco(var Data:TData; Mode:integer);
    procedure MT_EMatrix(var Data:TData; Mode:integer);

   public
    _prop_StrDelimiter:string;
    _prop_ColorDelimiter:string;
    _prop_MT_ColDelimiter:string;
    _prop_Grid:boolean;
    _prop_RowSelect:boolean;
    _prop_HeaderDragDrop:boolean;
    _prop_TrackSelect:boolean;
    _prop_ColorItems:boolean;    
    _prop_FileName:string;
    _prop_IconFileName:string;
    _prop_IconsFileName:string;
    _prop_ExtIconFileName:string;
    _prop_IListFileName:string;
    _prop_SaveColProp:boolean;
    _prop_SaveWidth:boolean;
    _prop_SaveImgIndex:boolean;
    _prop_SaveItemsColor:boolean;
    _prop_SaveColor:boolean;
    _prop_ClearAll:boolean;
    _prop_Redaction:boolean;
    _prop_ColumnClick:byte;
    _prop_MethodSort:byte;
    _prop_StaticColumn:boolean;
    _prop_Flat:boolean;
    _prop_CheckBoxes:boolean;
    _prop_TextAlign:TTextAlign;
    _prop_Style:TListViewStyle;
    _prop_MultiSelect:boolean;
    _prop_AutoMakeVisible:boolean;
    _prop_ImgColumn:boolean;
    _prop_TextColor:TColor;
    _prop_TextBkColor:TColor;
    _prop_BkColor:TColor;
    _prop_Transparent:TColor;
    _prop_IconColColor:TColor;
    _prop_IconToBmp:boolean;
    _prop_AssignedIList:boolean;
    _prop_ExtIconsCheck:boolean;
    _prop_FullSelect:boolean;
    _prop_ImgSize:byte;
    _prop_AppTxtStrLst:boolean;
    _prop_TableWBreak:boolean;
    _prop_Grid3D:boolean;    
    _prop_BumpText:boolean;
    _prop_AutoTblStrLst:boolean;
    _prop_ModeMakeVisible:byte;
    _prop_StyleGrid3D:byte;
    _prop_EnableOnClick:boolean;
    _prop_ComboBox:boolean;
    _prop_TypeComboInit:byte;
    _prop_MaxComboItem:integer;
    _prop_AllMT_AddCol:boolean;
    _prop_StrLstFName:string;
    _prop_ColumnWidth:integer;
    _prop_AutoAddItem:boolean;
    _prop_ComboTextColor:boolean;
    _prop_MaxColWidth:integer;
    _prop_MinColWidth:integer;
    
    _data_FileName:THI_Event;
    _data_IconFileName:THI_Event;
    _data_IconsFileName:THI_Event;
    _data_IListFileName:THI_Event;
    _data_EndEdit:THI_Event;
    _data_SFileExists_MT:THI_Event;
    _data_LFileExists_MT:THI_Event;
    _data_Str:THI_Event;
    _data_ExtCmp:THI_Event;
    _data_FTblStream:THI_Event;
    _data_StrLstFName:THI_Event;
    _data_StrLst:THI_Event;
    
    _event_onClick:THI_Event;
    _event_onColumnClick:THI_Event;
    _event_onChange:THI_Event;
    _event_onChangeImgLst:THI_Event;
    _event_onChangeColLst:THI_Event;
    _event_onGetIcon:THI_Event;
    _event_onGetMiscIcon:THI_Event; 
    _event_onGetIconIdx:THI_Event;
    _event_onMT_GetCol:THI_Event;
    _event_onMT_GetColors:THI_Event;
    _event_onMT_EMatrix:THI_Event;
    _event_onMT_Check:THI_Event;
    _event_onMT_SelString:THI_Event;
    _event_onExtIcon:THI_Event;
    _event_onChangeStrLst:THI_Event;
    _event_onGetStrList:THI_Event;
    _event_onBeforeLineChange:THI_Event;
    _event_onLineChange:THI_Event;
    _event_onComboClick:THI_Event;

    property _prop_Icons:PStrListEx write SetIcons;
    property _prop_IconsCheck:PStrListEx write SetIconsCheck;
    property _prop_MiscIcons:PStrListEx write SetMiscIcons;
    property _prop_StringsStrLst:string write SetTextStrLst;
    property _prop_Columns:string write SetTextColLst;

    constructor Create(Parent:PControl);
    procedure Init; override;
    destructor Destroy; override;

    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doInsert(var _Data:TData; Index:word);
    procedure _work_doAddColumn(var _Data:TData; Index:word);
    procedure _work_doSort(var _Data:TData; Index:word);
    procedure _work_doSortDigit(var _Data:TData; Index:word);
    procedure _work_doSortExtCmp(var _Data:TData; Index:word);
    procedure _work_doSelect(var _Data:TData; Index:word);
    procedure _work_doSelectString(var _Data:TData; Index:word);
    procedure _work_doEnsureVisible(var _Data:TData; Index:word);
    procedure _work_doCheckBox(var _Data:TData; Index:word);
    
    procedure _work_doInitTxtTab(var _Data:TData; Index:word);
    procedure _work_doReplace(var _Data:TData; Index:word);
    procedure _work_doLoadIcon(var _Data:TData; Index:word);
    procedure _work_doSaveIcon(var _Data:TData; Index:word);
    procedure _work_doSaveIList(var _Data:TData; Index:word);
    procedure _work_doLoadIList(var _Data:TData; Index:word);
    procedure _work_doLoadPakIcons(var _Data:TData; Index:word);
    procedure _work_doSaveFStream(var _Data:TData; Index:word);
    procedure _work_doLoadFStream(var _Data:TData; Index:word);
    procedure _work_doGetColors_MT(var _Data:TData; Index:word);
    procedure _work_doMT_Add(var _Data:TData; Index:word);
    procedure _work_doMT_AddCols(var _Data:TData; Index:word);
    procedure _work_doMT_Insert(var _Data:TData; Index:word);
    procedure _work_doMT_Replace(var _Data:TData; Index:word);    
    procedure _work_doMT_InsertCol(var _Data:TData; Index:word);
    procedure _work_doMT_ReplaceCol(var _Data:TData; Index:word);
    procedure _work_doMT_NameCol(var _Data:TData; Index:word);
    procedure _work_doMT_WidthCol(var _Data:TData; Index:word);
    procedure _work_doMT_ImageCol(var _Data:TData; Index:word);
    procedure _work_doMT_AlignTxtCol(var _Data:TData; Index:word);
    procedure _work_doMT_IconStr(var _Data:TData; Index:word);
    procedure _work_doMT_IconCol(var _Data:TData; Index:word);
    procedure _work_doMT_EMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_ChkEMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_SelEMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_ColorsStr(var _Data:TData; Index:word);
    procedure _work_doMT_CheckBox(var _Data:TData; Index:word);
    procedure _work_doMT_ReplaceIcon(var _Data:TData; Index:word);
    procedure _work_doMT_InsertIcon(var _Data:TData; Index:word);
    procedure _work_doMT_LoadExtIcon(var _Data:TData; Index:word);
    procedure _work_doClearCol(var _Data:TData; Index:word);
    procedure _work_doDeleteCol(var _Data:TData; Index:word);
    procedure _work_doGetCol_MT(var _Data:TData; Index:word);
    procedure _work_doCheckBoxes(var _Data:TData; Index:word);
    procedure _work_doTextColor(var _Data:TData; Index:word);
    procedure _work_doTextBkColor(var _Data:TData; Index:word);
    procedure _work_doBkColor(var _Data:TData; Index:word);
    procedure _work_doAutoMakeVisible(var _Data:TData; Index:word);
    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doTextAlign(var _Data:TData; Index:word);
    procedure _work_doSaveColProp(var _Data:TData; Index:word);
    procedure _work_doSaveImgIndex(var _Data:TData; Index:word);
    procedure _work_doSaveItemsColor(var _Data:TData; Index:word);
    procedure _work_doSaveColor(var _Data:TData; Index:word);
    procedure _work_doSaveWidth(var _Data:TData; Index:word);
    procedure _work_doGrid(var _Data:TData; Index:word);
    procedure _work_doStaticColumn(var _Data:TData; Index:word);
    procedure _work_doHeaderDragDrop(var _Data:TData; Index:word);
    procedure _work_doTrackSelect(var _Data:TData; Index:word);
    procedure _work_doRowSelect(var _Data:TData; Index:word);
    procedure _work_doMultiSelect(var _Data:TData; Index:word);
    procedure _work_doGetIcon(var _Data:TData; Index:word);
    procedure _work_doGetIconIdx(var _Data:TData; Index:word);
    procedure _work_doDeleteIcon(var _Data:TData; Index:word);
    procedure _work_doTransparent(var _Data:TData; Index:word);
    procedure _work_doClearIcons(var _Data:TData; Index:word);
    procedure _work_doMethodSort(var _Data:TData; Index:word);
    procedure _work_doSelEndStr(var _Data:TData; Index:word);
    procedure _work_doEndEdit(var _Data:TData; Index:word);
    procedure _work_doStartEdit(var _Data:TData; Index:word);
    procedure _work_doGetMiscIcon(var _Data:TData; Index:word);    
    procedure _work_doAddStrLst(var _Data:TData; Index:word);
    procedure _work_doClearStrLst(var _Data:TData; Index:word);
    procedure _work_doDeleteStrLst(var _Data:TData; Index:word);
    procedure _work_doLoadStrLst(var _Data:TData; Index:word);
    procedure _work_doSaveStrLst(var _Data:TData; Index:word);
    procedure _work_doAppendStrFile(var _Data:TData; Index:word);
    procedure _work_doInsertStrLst(var _Data:TData; Index:word);
    procedure _work_doTextStrLst(var _Data:TData; Index:word);
    procedure _work_doTblStrLst(var _Data:TData; Index:word);    
    procedure _work_doAddTextStrLst(var _Data:TData; Index:word);
    procedure _work_doSortStrLst(var _Data:TData; Index:word);
    procedure _work_doGetStrList(var _Data:TData; Index:word);
    procedure _work_doTableWBreak(var _Data:TData; Index:word);
    procedure _work_doGrid3D(var _Data:TData; Index:word);
    procedure _work_doBumpText(var _Data:TData; Index:word);
    procedure _work_doModeMakeVisible(var _Data:TData; Index:word);
    procedure _work_doStyleGrid3D(var _Data:TData; Index:word);
    procedure _work_doEnableOnClick(var _Data:TData; Index:word);
    procedure _work_doEnableCombo(var _Data:TData; Index:word);
    procedure _work_doComboColumn(var _Data:TData; Index:word);
    procedure _work_doComboInit(var _Data:TData; Index:word);
    procedure _work_doAutoColWidth(var _Data:TData; Index:word);
    procedure _work_doMaxColWidth(var _Data:TData; Index:word);

    procedure _var_GenColors_MT(var _Data:TData; Index:word);
    procedure _var_AllSelect_MT(var _Data:TData; Index:word);
    procedure _var_AllCheck_MT(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_EndIdx(var _Data:TData; Index:word);    
    procedure _var_Select(var _Data:TData; Index:word);
    procedure _var_Matrix(var _Data:TData; Index:word);
    procedure _var_Strings(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
    procedure _var_StringTable(var _Data:TData; Index:word);
    procedure _var_SelectArray(var _Data:TData; Index:word);
    procedure _var_ColumnArray(var _Data:TData; Index:word);
    procedure _var_IconArray(var _Data:TData; Index:word);
    procedure _var_CheckBoxes(var _Data:TData; Index:word);
    procedure _var_CountIcons(var _Data:TData; Index:word);
    procedure _var_EndIdxIcons(var _Data:TData; Index:word);    
    procedure _var_CountCol(var _Data:TData; Index:word);
    procedure _var_EndIdxCol(var _Data:TData; Index:word);    
    procedure _var_FullTextTab(var _Data:TData; Index:word);    
    procedure _var_FStream(var _Data:TData; Index:word);
    procedure _var_CountStrLst(var _Data:TData; Index:word);
    procedure _var_EndIdxStrLst(var _Data:TData; Index:word);    
    procedure _var_TextStrLst(var _Data:TData; Index:word);
    procedure _var_StrLstArray(var _Data:TData; Index:word);

  end;

function MakeArrayIcon(Names:PChar; Values:array of integer):PStrListEx;

implementation

function ThiStringTable.GetSmallIcon(Path: String; IconIndex: Integer): hIcon;
var Licon,sIcon:hIcon;
begin
    ExtractIconEx(PChar(Path),IconIndex,Licon,sIcon,1);
    Result:= hIcon(sIcon); 
end;

function MakeArrayIcon;begin Result:= MakeArrayInteger(Names,Values);end;

constructor ThiStringTable.Create;
begin
   inherited Create(Parent);
   Icon:= NewIcon;
end;

destructor ThiStringTable.Destroy;
begin
   if Assigned(ComboBox)   then begin ComboBox.Text:=''; ComboBox.free; end;
   If Assigned(Icon)       then Icon.free;
   If Assigned(IList)      then IList.free;
   If Assigned(IChList)    then IChList.free;
   If Assigned(CList)      then CList.free;
   If Assigned(FList)      then FList.free;
   If Assigned(IDList)     then IDList.free;
   If Assigned(FTblStream) then FTblStream.free;
   if Obj <> nil           then Dispose(Obj);
   if CBArray <> nil       then Dispose(CBArray);
   if SAArray <> nil       then Dispose(SAArray);
   if CLArray <> nil       then Dispose(CLArray);
   if ICArray <> nil       then Dispose(ICArray);
   if SLArray <> nil       then Dispose(SLArray);      
   inherited Destroy;
end;

procedure ThiStringTable._OnColumnClick;
begin
   case _prop_ColumnClick of
     0: _hi_OnEvent(_event_onColumnClick,Control.LVColText[Idx]);
     1: _hi_OnEvent(_event_onColumnClick,Idx);
   end;
end;

procedure ThiStringTable._OnBeforeLineChange;begin _hi_OnEvent(_event_onBeforeLineChange,Idx);end;
procedure ThiStringTable._OnLineChange;begin _hi_OnEvent(_event_onLineChange,Idx);end;

//---------------------       -----------------------

procedure ThiStringTable._OnSelState;
var   dt,Data:TData;
      s:string;
begin
   dtNull(Data);
   if _FlagCombo then Combobox.Visible:= False;
   if (Newstate = 3) or (Newstate = 1) then begin
      if _FlagCombo then begin;
         ComboItem:= IdxFrom;
         ComboTopItem:= Sender.LVTopItem;
         ComboBox.CurIndex:= 0;
         s:= Sender.LVItems[IdxFrom, ComboCol]; 
         if (_prop_AutoAddItem) and (ComboBox.Count < _prop_MaxComboItem) then begin
            if ComboBox.Insert(0,'') = -1 then ComboBox.Add('');
            ComboBox.CurIndex:= 0;
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
            if ComboBox.CurIndex > 0 then
               ComboBox.Delete(0)
            else begin
               ComboBox.Delete(0);
               ComboBox.Add(s);
            end;   
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
         end
         else
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
         _FlagRedraw:= True;
      end;
      if  _prop_EnableOnClick then _hi_OnEvent(_event_onClick,IdxFrom);
   end
   else if (Newstate = $2000) and (OldState =  $1000) then begin
      dtInteger(Data,IdxFrom);
      dtInteger(dt,1);
      Data.ldata:= @dt;
      _hi_onEvent_(_event_onMT_Check,Data);
   end
   else if (Newstate = $1000) and (OldState =  $2000) then begin
      dtInteger(Data,IdxFrom);
      dtInteger(dt,0);
      Data.ldata:= @dt;
      _hi_onEvent_(_event_onMT_Check,Data);
   end;
end;

//---------------------       -----------------------

function ThiStringTable._OnLVCustomDraw;
var   Color,bkColor:TColor;
      idxColor:dword;
      str:string;
      ARect,BRect,CRect:TRect;
      _Flags:dword;
      ColorText,ColorBack:TColor;
      l:TListViewOptions;
begin
TRY
   Result:= CDRF_DODEFAULT;
   if (Stage = CDDS_PREPAINT) then Result:= CDRF_NOTIFYITEMDRAW
   else if (Stage = CDDS_ITEMPREPAINT) then begin 
      if (Sender.LVItemData[ItemIdx] <> 0)  and (_prop_ColorItems) then begin
         Color:= Sender.LVItemData[ItemIdx];
         bkColor:= $00FFFFFF and Color;
         if bkColor <> 0 then BackColor:= bkColor;
         idxColor:= ($0F000000 and Color) shr 24;
         if idxColor <> 0 then TextColor:= AColor[idxColor];
      end;
      Result:=CDRF_NOTIFYSUBITEMDRAW
   end
   else if (Stage = CDDS_SUBITEM + CDDS_ITEMPREPAINT) and ((_prop_Style = lvsDetail) or (_prop_Style = lvsDetailNoHeader)) and _prop_TableWBreak then begin
      l:= Control.LVOptions;
      str:= Sender.LVItems[ItemIdx,SubItemIdx];
      ARect:= Sender.LVSubItemRect(ItemIdx,SubItemIdx);
      if SubItemIdx = 0 then ARect.Right:= Arect.Left + Sender.LVColWidth[SubItemIdx];
      if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then
         ColorBack:= clHighlight
      else
         if BackColor <> 0 then ColorBack:= BackColor else ColorBack:= _prop_TextBkColor;  
      FillRect(DC,ARect,CreateSolidBrush(Color2RGB(ColorBack)));
      BRect:= ARect;
      ARect.Left:= ARect.Left + Sender.Canvas.TextExtent('M').cx;
      ARect.Right:= ARect.Right - Sender.Canvas.TextExtent('M').cx; 
      _Flags:= DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER;
      if (Sender.Canvas.TextExtent(Sender.LVItems[ItemIdx,SubItemIdx]).cx > ARect.Right - ARect.Left) then begin
         CRect:= ARect;
         ARect.Top:= ARect.Top + Sender.Canvas.TextExtent('W').cy div 2;
         ARect.Bottom:= ARect.Bottom - Sender.Canvas.TextExtent('W').cy div 2;
         if ARect.Bottom - ARect.Top < Sender.Canvas.TextExtent('W').cy then ARect:= CRect;   
         case integer(Sender.LVColAlign[SubItemIdx]) of
            0: _Flags:= _Flags or DT_WORDBREAK or DT_LEFT; 
            1: _Flags:= _Flags or DT_WORDBREAK or DT_RIGHT;
            2: _Flags:= _Flags or DT_WORDBREAK or DT_CENTER;
         end;
      end
      else   
         case integer(Sender.LVColAlign[SubItemIdx]) of
            0: _Flags:= _Flags or DT_SINGLELINE or DT_LEFT;
            1: _Flags:= _Flags or DT_SINGLELINE or DT_RIGHT;
            2: _Flags:= _Flags or DT_SINGLELINE or DT_CENTER;
         end;
      CRect.Left:= ARect.Left + 1;
      CRect.Top:= ARect.Top + 1;
      CRect.Right:= ARect.Right + 1;
      CRect.Bottom:= ARect.Bottom + 1;
      if _prop_BumpText then begin
         ColorText:= clHighlightText;
         if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then CRect:=ARect;    
         SetBkMode(DC,Color2RGB(ColorText));
         SetTextColor(DC,Color2RGB(ColorText));
         DrawText(DC,PChar(str),-1,CRect,_Flags);
      end;
      if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then
         ColorText:= clHighlightText
      else
         if TextColor <> 0 then ColorText:= TextColor else ColorText:= _prop_TextColor;
      SetBkMode(DC,Color2RGB(ColorText));
      SetTextColor(DC,Color2RGB(ColorText));
      DrawText(DC,PChar(str),-1,ARect,_Flags);
      _Flags:= EDGE_RAISED;
      case _prop_StyleGrid3D of
         0: _Flags:= EDGE_RAISED;
         1: _Flags:= EDGE_SUNKEN;
      end;
      if (lvoGridLines in l) and _prop_Grid3D then
         DrawEdge(DC, BRect,_Flags, BF_RECT)
      else if (lvoGridLines in l) then
         DrawEdge(DC, BRect,BDR_RAISEDINNER, BF_RECT or BF_FLAT);
      Result:= CDRF_SKIPDEFAULT;
   end;
FINALLY
   if (ComboTopItem - Sender.LVTopItem <> 0) and _prop_ComboBox then begin 
      _FlagRedraw:= False;
      ComboBox.Visible:= False;
   end;
   if _FlagRedraw and _prop_ComboBox then begin
      ARect:= Sender.LVSubItemRect(ComboItem, ComboCol);
      ComboBox.Width:= Sender.LVColWidth[ComboCol];
      if ComboBox.Height < _prop_Imgsize then 
         ARect.Top:= ARect.Top + round((_prop_Imgsize - ComboBox.Height)/2);
      ComboBox.Top:= ARect.Top;
      indent:= 0;
      if _prop_CheckBoxes then indent:= _prop_Imgsize;
      if Assigned(IList) then indent:=  indent + _prop_Imgsize;
      if Assigned(IChList) or _prop_CheckBoxes then indent:= indent + 2; 
      if (ComboCol = 0) and not _prop_TableWBreak then begin
         ARect.Left:= ARect.Left + indent;
         ComboBox.Width:= ComboBox.Width - indent;
      end;
      ComboBox.Left:= ARect.Left;
      ComboBox.Visible:= True;   
      _FlagRedraw:= False;
   end;
END;
end;

function ThiStringTable.PakColor2Str;
var   hcl,lcl:string;
      idxcl:dword;
begin
   lcl:= int2str($FFFFFF and data);
   idxcl:= $0F000000 and data;
   hcl:= int2str(idxcl shr 24);
   Result:= hcl + _ColorDlm + lcl;
end;

procedure ThiStringTable.Init;
var   l:TListViewOptions;
      ind:integer;
begin
   if _prop_MaxComboItem < 0 then _prop_MaxComboItem:= MAXLONG;
   _FlagCombo:= _prop_ComboBox and not _prop_Redaction;
   l:= [lvoInfoTip, lvoUnderlineHot];
   if _prop_TrackSelect then include(l,lvoTrackSelect);
   if _prop_HeaderDragDrop then include(l,lvoHeaderDragDrop);
   if _prop_CheckBoxes then include(l,lvoCheckBoxes);
   if _prop_MultiSelect and not _prop_ComboBox then include(l,lvoMultiSelect);
   if _prop_Flat then include(l,lvoFlatsb);
   if _prop_Grid then include(l,lvoGridLines);
   if _prop_RowSelect then include(l,lvoRowSelect);
   if _prop_StrDelimiter = '' then _prop_StrDelimiter:= ' ';_StrDlm:= _prop_StrDelimiter[1]; 
   if _prop_ColorDelimiter = '' then _prop_ColorDelimiter:= '#';_ColorDlm:= _prop_ColorDelimiter[1]; 
   if _prop_MT_ColDelimiter = '' then _prop_MT_ColDelimiter:= '_';_MTColDlm:= _prop_MT_ColDelimiter[1];

   if not Assigned (IDList) then IDList:= NewStrListEx;

   if (not Assigned (IList)) and _prop_AssignedIList then
      begin
         IList:= NewImageList(Control);
         if _prop_Imgsize = 0 then _prop_Imgsize:= GetSystemMetrics(SM_CXICON);
         SetIListProp;
      end;
   if _prop_Redaction then
      if (Assigned (IChList)) and (_prop_ExtIconsCheck) then
           Control := NewListEdit(FParent,_prop_Style,l,IList,IList,IChList,_OnLineChange,_OnBeforeLineChange)
      else Control := NewListEdit(FParent,_prop_Style,l,IList,IList,nil,_OnLineChange,_OnBeforeLineChange)
   else
      if (Assigned (IChList)) and (_prop_ExtIconsCheck) then
           Control := NewListView(FParent,_prop_Style,l,IList,IList,IChList)
      else Control := NewListView(FParent,_prop_Style,l,IList,IList,nil);

   Control.OnColumnClick:=   _OnColumnClick;
   Control.OnLVCustomDraw:=  _OnLVCustomDraw;
   
   inherited;

   Control.LVTextColor:= _prop_TextColor;
   Control.LVTextBkColor:= _prop_TextBkColor;
   Control.LVBkColor:= _prop_BkColor;
   Control.LVStyle:= _prop_Style;

   If _FlagCombo then begin
      ComboBox:= NewComboBox(Control,[coNoIntegralHeight,coReadOnly]);   
      ComboBox.Visible:= False;
      ComboBox.Color:= Control.Color;
      if _prop_ComboTextColor then ComboBox.Font.Color:= _prop_TextColor;
      ComboBox.onSelChange:= _onComboClick;
   end;

   Control.OnLVStateChange:= _OnSelState;
   SetColumns(CList,0);
   if _prop_AutoTblStrLst then for ind:= 0 to FList.Count - 1 do Add(FList.Items[ind]);
end;

procedure ThiStringTable._onComboClick;
begin
   if not _FlagCombo then Exit;
   Control.LVItems[ComboItem, ComboCol]:= ComboBox.Items[ComboBox.CurIndex]; 
   ComboBox.Visible:= False;
   _hi_OnEvent(_event_onComboClick,Control.LVItems[ComboItem, ComboCol]);
end;

procedure ThiStringTable.SetTextColLst;
begin
   CList:= NewStrList;
   Clist.Text:= Value;
end;

procedure ThiStringTable.SetColumns;
var   i:integer;
      s,str,sd:string;
begin
   if ListCol.Count = 0 then exit;
   i:= 0;
   Control.BeginUpdate;
   repeat
      s:= ListCol.Items[i] + '=';
      sd:= GetTok(s,'=');
      if sd <> '' then begin
         str:= sd;
         case Mode of
            0:  Control.LVColAdd(sd,_prop_TextAlign,_prop_ColumnWidth);
            1:  Control.LVColText[i]:= sd;
         end;
         sd:= GetTok(s,'=');
         if sd = '' then
            sd:= int2str(_prop_ColumnWidth)
         else
            Control.LVColWidth[i]:= max(LVSCW_AUTOSIZE_USEHEADER,str2int(sd));
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if _prop_ImgColumn and Assigned(Ilist) and (IList.Count <> 0) then
            Control.LVColImage[i]:= str2int(sd);
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if sd <> '' then
            Control.LVColAlign[i]:= TTextAlign(str2int(sd))
         else begin
            Control.LVColAlign[i]:= _prop_TextAlign;
            sd:= int2str(integer(Control.LVColAlign[i]));
         end;
         str:= str + '=' + sd;
         ListCol.Items[i]:= str;
      end;
      inc(i);
   until i = ListCol.Count; 
   Control.EndUpDate;
end;

procedure ThiStringTable._work_doAdd;
begin
   Add(ReadString(_Data,_data_Str,''));
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doInitTxtTab;
var   List:PStrList;
      ind:integer;
begin
   List:= NewStrList;
   List.Text:= ReadString(_Data,_data_StrLst,'');
   for ind:= 0 to List.Count - 1 do Add(List.Items[ind]);
   List.free;
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doInsert;
begin
   Add(ToStringEvent(_data_Str),ToInteger(_Data),false);
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable.Add;
var   s,ss:string;
      i,ico:integer;
      DColor:dword;       
begin
   s:= Data + _StrDlm;
   i:= 0;
   ico:= I_SKIP;
   DColor:= 0;
   if Index = -1 then begin
      Control.LVItemAdd('');
      Index:= Control.Count-1;
   end else if not _replace then Control.LVItemInsert(Index,'');
   if Assigned(Ilist) then ico:= Str2Int(gettok(s,_StrDlm));
   if _prop_ColorItems then begin
      ss:= gettok(s,_StrDlm) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
   end;
   repeat
      Control.LVSetItem(Index,i,gettok(s,_StrDlm),ico,[],I_SKIP,I_SKIP,DColor);
      inc(i);
   until s = '';
end;

procedure ThiStringTable._work_doClear;
begin
   Control.BeginUpdate;
   Control.Clear;
   if _prop_ClearAll then begin
      repeat
         Control.LVColDelete(Control.LVColCount-1);
      until Control.LVColCount <= 0;
      CList.Clear;
   end;
   Control.EndUpdate;
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doSelect;
var   ind,begitm:integer;
begin
   ind:= ToInteger(_Data);
   Control.LVCurItem:= ind; 
   If not _prop_AutoMakeVisible then Exit;
   if (_prop_Style = lvsDetail) or (_prop_Style = lvsDetailNoHeader) then
      case _prop_ModeMakeVisible of
         1: begin
               begitm:= ind + Control.LVPerPage;
               if begitm > Control.Count - 1 then begitm:= Control.Count - 1; 
               ind:= begitm - Control.LVPerPage; 
               Control.LVMakeVisible(begitm,false);
            end;
         2: begin 
               begitm:= ind + Control.LVPerPage div 2;
               if begitm > Control.Count - 1 then begitm:= Control.Count - 1; 
               ind:= begitm - Control.LVPerPage; 
               if ind < 0 then ind:= 0;
               Control.LVMakeVisible(begitm,false);
            end;
         3: begin
               begitm:= ind - Control.LVPerPage;
               if begitm < 0 then begitm:= 0;
               Control.LVMakeVisible(begitm,false);
            end;
      end; 
   Control.LVMakeVisible(ind,false);
end;

procedure ThiStringTable._work_doEnsureVisible;
begin
   If _prop_AutoMakeVisible then exit;
   Control.LVMakeVisible(ToInteger(_Data), False);
end;

procedure ThiStringTable._work_doDelete;
begin
   Control.LVDelete(ToInteger(_Data));
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doReplace;
begin
   Add(ToStringEvent(_data_Str),ToInteger(_Data),true);
   _hi_onEvent(_event_onChange);
end;

function ThiStringTable._OnCmpText;
var   S1,S2:string;
begin
   S1 := Sender.LVItems[ Idx1, SortCol ];
   S2 := Sender.LVItems[ Idx2, SortCol ];
   if _prop_MethodSort = 1 then
      Result := AnsiCompareStrNoCase( S2, S1 )
   else
      Result := AnsiCompareStrNoCase( S1, S2 );
end;

function ThiStringTable._OnCmpReal;
var   S1,S2:string; r:real;
begin
   S1 := Sender.LVItems[ Idx1, SortCol ];
   S2 := Sender.LVItems[ Idx2, SortCol ];
   r := str2double(S1)-str2double(S2);
   if _prop_MethodSort = 1 then
      Result := ord(r<0)-ord(r>0)
   else
      Result := ord(r>0)-ord(r<0);
end;

function ThiStringTable._OnCmpExt;
var dt1,dt2:TData; r:real;
begin
   dtString(dt1, Sender.LVItems[ Idx1, SortCol ]);
   dtString(dt2, Sender.LVItems[ Idx2, SortCol ]);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_ExtCmp);
   r := ToReal(dt1);
   if _prop_MethodSort = 1 then
      Result := ord(r<0)-ord(r>0)
   else
      Result := ord(r>0)-ord(r<0);
end;

procedure ThiStringTable._work_doSort;
begin
   Control.OnCompareLVItems := _OnCmpText;
   SortCol := ToInteger(_Data);
   Control.LVSort;
   if _FlagCombo then ComboBox.Visible:= False;
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doSortDigit;
begin
   Control.OnCompareLVItems := _OnCmpReal;
   SortCol := ToInteger(_Data);
   Control.LVSort;
   if _FlagCombo then ComboBox.Visible:= False;
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doSortExtCmp;
begin
   Control.LVMakeVisible(Control.LVCurItem,false);
   Control.OnCompareLVItems := _OnCmpExt;
   SortCol := ToInteger(_Data);
   Control.LVSort;
   if _FlagCombo then ComboBox.Visible:= False;
   _hi_onEvent(_event_onChange);
end;

function ThiStringTable.Get;
var   i:integer;
      s:string;
begin
   Result := '';
   if Control.LVColCount > 0 then
      begin
         s:= '';
         if (Assigned(Ilist)) and _prop_FullSelect then
            s:= int2str(Control.LVItemImageIndex[Index]) + _StrDlm;
         if _prop_ColorItems and _prop_FullSelect  then
            s:= s + PakColor2Str(Control.LVItemData[Index]) + _StrDlm;;
         for i:= 0 to Control.LVColCount - 1 do
            begin
               s:= s + Control.LVItems[Index,i];
               if i < Control.LVColCount - 1 then
                  s:= s + _StrDlm;
            end;
         Result:= s;   
      end;
end;

procedure ThiStringTable._aSet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
     Add(ToString(val),ind, true);
end;

procedure ThiStringTable._aAdd;
begin
   Add(ToString(val), -1);
end;

function ThiStringTable._aGet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
     begin
        Result := true;
        dtString(Val,Get(ind));
     end
   else Result := false;
end;

function ThiStringTable._aCount;
begin
   Result := Control.Count;
end;

procedure ThiStringTable._var_Strings;
begin
  if arr = nil then
     arr := CreateArray(_aset,_aget,_acount,_aadd);
  dtArray(_Data,Arr);
end;

procedure ThiStringTable._var_Count;
begin
   dtInteger(_Data,Control.Count);
end;

procedure ThiStringTable._var_EndIdx;
begin
   if Control.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,Control.Count - 1);
end;

procedure ThiStringTable._var_Select;
begin
   dtString(_Data,'');
   if Control.LVCurItem = -1 then Exit;
   dtString(_Data,Get(Control.LVCurItem));
end;

procedure ThiStringTable._var_FullTextTab;
var   i,j:integer;
      s:string;
begin
   if (Control.Count = 0) or (Control.LVColCount = 0) then Exit;
   s:= '';
   j:= 0;
   repeat
      if Assigned(Ilist) then s:= s + int2str(Control.LVItemImageIndex[j]) + _StrDlm;
      if _prop_ColorItems then s:= s + PakColor2Str(Control.LVItemData[j]) + _StrDlm;
      i:= 0;
      repeat
         s:= s + Control.LVItems[j,i];
         if i < Control.LVColCount - 1 then s:= s + _StrDlm;
         inc(i);
      until i > Control.LVColCount - 1; 
      s:= s + #13#10;
      inc(j);
   until j > Control.Count - 1;
   dtString(_Data,s);
end;

procedure ThiStringTable._var_Index;
begin
   dtInteger(_Data,Control.CurIndex);
end;

procedure ThiStringTable._var_StringTable;
begin
   _Data.Data_type := data_int;
   _Data.sdata := 'StringTable';
   _Data.idata := integer(Control);
end;

procedure ThiStringTable._var_SelectArray;
begin
   if not Assigned(SAArray) then
      SAArray := CreateArray(SA_Set,SA_Get,SACB_Count,nil);
   dtArray(_Data,SAArray);
end;

procedure ThiStringTable.SA_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count)and(ToInteger(Val) = 1) then
   Control.LVItemState[ind]:= [lvisSelect];
end;

function ThiStringTable.SA_Get(Var Item:TData; var Val:TData):boolean;
var  ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if (ind >= 0)and(ind < Control.Count) then
      if lvisSelect in Control.LVItemState[ind] then dtInteger(Val,1) else dtInteger(Val,0)
   else Result:= False;
end;

procedure ThiStringTable._var_CheckBoxes;
begin
   if not Assigned(CBArray) then
      CBArray := CreateArray(CB_Set,CB_Get,SACB_Count,nil);
   dtArray(_Data,CBArray);
end;

procedure ThiStringTable.CB_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      Control.LVItemStateImgIdx[ind]:= toInteger(Val) + 1;
end;

function ThiStringTable.CB_Get(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      begin
         dtInteger(Val,Control.LVItemStateImgIdx[ind] - 1);
         Result:= True;
      end
   else Result:= False;
end;

function ThiStringTable.SACB_Count:integer;
begin
   Result:= Control.Count;
end;

procedure ThiStringTable._work_doSelEndStr;
begin
   If not _prop_AutoMakeVisible Then Exit;
   Control.LVCurItem:= Control.Count - 1;
   Control.LVMakeVisible(Control.Count - 1,True);
end;

procedure ThiStringTable.SetOption;
var   l:TListViewOptions;
begin
   l:= Control.LVOptions;
   if OSet then include(l,Option)
   else exclude(l,Option);
   Control.LVOptions:= l;
end;

procedure ThiStringTable._work_doTextColor;begin _prop_TextColor:= ToInteger(_Data);Control.LVTextColor:= _prop_TextColor;Control.Invalidate;end;
procedure ThiStringTable._work_doTextBkColor;begin _prop_TextBkColor:= ToInteger(_Data);Control.LVTextBkColor:= _prop_TextBkColor;Control.Invalidate;end;
procedure ThiStringTable._work_doBkColor;begin _prop_BkColor:= ToInteger(_Data);Control.LVBkColor:= _prop_BkColor;Control.Invalidate;end;
procedure ThiStringTable._work_doTransparent;begin _prop_Transparent:= ToInteger(_Data);end;
procedure ThiStringTable._work_doAutoMakeVisible;begin _prop_AutoMakeVisible:= ReadBool(_Data);end;
procedure ThiStringTable._work_doStyle;begin _prop_Style:= TListViewStyle(ToInteger(_Data));Control.LVStyle:= _prop_Style;SetColumns(Clist,1);end;
procedure ThiStringTable._work_doTextAlign;begin _prop_TextAlign:= TTextAlign(ToInteger(_Data));end;
procedure ThiStringTable._work_doSaveColProp;begin _prop_SaveColProp:= ReadBool(_Data);end;
procedure ThiStringTable._work_doSaveWidth;begin _prop_SaveWidth:= ReadBool(_Data);end;
procedure ThiStringTable._work_doSaveImgIndex;begin _prop_SaveImgIndex:= ReadBool(_Data);end;
procedure ThiStringTable._work_doSaveItemsColor;begin _prop_SaveItemsColor:= ReadBool(_Data);end;
procedure ThiStringTable._work_doSaveColor;begin _prop_SaveColor:= ReadBool(_Data);end;
procedure ThiStringTable._work_doStaticColumn;begin _prop_StaticColumn:= ReadBool(_Data);end;
procedure ThiStringTable._work_doMethodSort;begin _prop_MethodSort:= ToInteger(_Data);end;
procedure ThiStringTable._work_doTableWBreak;begin _prop_TableWBreak:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTable._work_doGrid3D;begin _prop_Grid3D:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTable._work_doBumpText;begin _prop_BumpText:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTable._work_doModeMakeVisible;begin _prop_ModeMakeVisible:= ToInteger(_Data);end;
procedure ThiStringTable._work_doStyleGrid3D;begin _prop_StyleGrid3D:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiStringTable._work_doEnableOnClick;begin _prop_EnableOnClick:= ReadBool(_Data);end;

procedure ThiStringTable._work_doGrid;
begin
   _prop_Grid:= ReadBool(_Data);
   SetOption(_prop_Grid,lvoGridLines);
end;

procedure ThiStringTable._work_doHeaderDragDrop;
begin
   _prop_HeaderDragDrop:= ReadBool(_Data);
   SetOption(_prop_HeaderDragDrop,lvoHeaderDragDrop);
end;

procedure ThiStringTable._work_doTrackSelect;
begin
   _prop_TrackSelect:= ReadBool(_Data);
   SetOption(_prop_TrackSelect,lvoTrackSelect);
end;

procedure ThiStringTable._work_doRowSelect;
begin
   _prop_RowSelect:= ReadBool(_Data);
   SetOption(_prop_RowSelect,lvoRowSelect);
end;

procedure ThiStringTable._work_doCheckBoxes;
begin
   if _prop_ExtIconsCheck then exit;
   _prop_CheckBoxes:= ReadBool(_Data);
   SetOption(_prop_CheckBoxes,lvoCheckBoxes);
   if ComboBox.Visible = True then _FlagRedraw:= True;
end;

procedure ThiStringTable._work_doCheckBox;
var   s:string;
      i:integer;
begin
   s:= ToString(_Data);
   i:= str2int(GetTok(s,'='));
   Control.LVItemStateImgIdx[i]:= str2int(s);
//   Control.EndUpdate;
end;

procedure ThiStringTable._work_doMultiSelect;
begin
   if Assigned(ComboBox) then exit;
   _prop_MultiSelect:= ReadBool(_Data);
   SetOption(_prop_MultiSelect,lvoMultiSelect);
end;

//#####################################################################
//#                                                                   #
//#                               #
//#                                                                   #
//#####################################################################

//------------------         --------------------

procedure ThiStringTable._var_ColumnArray;
begin
  if not Assigned(CLArray) then
     CLArray := CreateArray(_SetCol,_GetCol,_CountCol,_AddCol);
  dtArray(_Data,CLArray);
end;

procedure ThiStringTable._SetCol(var Item:TData; var Val:TData);
var   s:string;
      ind:integer;
begin
   ind:= ToIntIndex(Item);
   s:= ToString(Val);
   if(ind >= 0)and(ind < CList.Count) then CList.Items[ind]:=InitColStr(s);
   SetColumns(CList,1);
end;

function ThiStringTable._GetCol(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if(ind >= 0)and(ind < CList.Count) then
      dtString(Val,Clist.Items[ind])
   else Result:= False;
end;

function ThiStringTable._CountCol:integer;
begin
   Result:= CList.Count;
end;

procedure ThiStringTable._AddCol(var Val:TData);
begin
   _work_doAddColumn(Val,0);
end;

//--------------------       -----------------------

procedure ThiStringTable._work_doAddColumn;
var   s:string;
begin
   s:= ToString(_Data);
   Control.LVColAdd('',_prop_TextAlign,_prop_ColumnWidth);
   CList.Add(InitColStr(s));
   SetColumns(CList,1);
   if integer(Index) = 0 then exit;
   _hi_onEvent(_event_onChangeColLst);
end;

procedure ThiStringTable._work_doDeleteCol;
var   ind:integer;
begin
   ind:= ToInteger(_Data);
   if(ind >= 0)and(ind < CList.Count) then
      begin
         Control.LVColDelete(ind);
         CList.Delete(ind);
      end;
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeColLst);
end;

procedure ThiStringTable._work_doClearCol;
var   x,y:integer;
      dt:TData;
begin
    dtNull(dt);
    x:= ToInteger(_Data);
    if(x >= 0)and(x < CList.Count) then
       for y:= 0 to Control.Count - 1 do MX_Set(x,y,dt);
   Control.Invalidate;
   _hi_onEvent(_event_onChange);
end;

function ThiStringTable.InitColStr;
var   s,ss,sd,se,sf,sh:string;
begin
   s:= val;
   sf:= s + '=';
   ss:= GetTok(sf,'=');
   sd:= GetTok(sf,'=');
   sh:= GetTok(sf,'=');
   se:= GetTok(sf,'=');
   if s = '' then s:= '=' + int2str(_prop_ColumnWidth) + '=' + int2str(integer(_prop_TextAlign))
   else begin
      if sd = '' then sd:= int2str(_prop_ColumnWidth);
      if se = '' then se:= int2str(integer(_prop_TextAlign));
      s:= ss + '=' + sd + '=' + sh + '=' + se;
   end;
   Result:= s;
end;

//--------------------       ----------------------

procedure ThiStringTable._var_CountCol;
begin
   dtInteger(_Data,CList.Count);
end;

procedure ThiStringTable._var_EndIdxCol;
begin
   if CList.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,CList.Count - 1);
end;

//#####################################################################
//#                                                                   #
//#                                                #
//#                                                                   #
//#####################################################################

procedure ThiStringTable._var_Matrix;
begin
   if not Assigned(Obj) then begin
      New(Obj);
      Obj._Set:= MX_Set;
      Obj._Get:= MX_Get;
   end;
   dtMatrix(_Data,Obj);
end;

function ThiStringTable.MX_Get;
begin
   if(x >= 0)and(y >= 0)and(y < Control.Count)and(x < Control.LVColCount) then
      dtString(Result,Control.LVItems[y,x])
   else dtNull(Result);
end;

procedure ThiStringTable.MX_Set;
begin
   if(x >= 0)and(y >= 0)and(y < Control.Count)and(x < Control.LVColCount) then
     Control.LVItems[y,x]:= ToString(Val);
end;

//#####################################################################
//#                                                                   #
//#                                     #
//#                                                                   #
//#####################################################################

//-----------------        -------------------

procedure ThiStringTable.SetIcons;
var i:integer;
begin
   if not _prop_AssignedIList then exit;
   IList:= NewImageList(Control);
   if _prop_Imgsize = 0 then _prop_Imgsize:= GetSystemMetrics(SM_CXICON);
   SetIListProp;
   for i:= 0 to Value.Count - 1 do IList.AddIcon(Value.Objects[i]);
end;

//-------------        ----------------

procedure ThiStringTable.SetIconsCheck;
var i:integer;
begin
   IChList:= NewImageList(Control);
   IChList.BkColor:= _prop_BkColor;
   IChList.ImgWidth:= _prop_ImgSize;
   IChList.ImgHeight:= _prop_ImgSize;
   for i:= 0 to Value.Count - 1 do IChList.AddIcon(Value.Objects[i]);
end;

//----------        ------------

procedure ThiStringTable.SetMiscIcons;
begin
   IDList:= NewStrListEx;
   IDList.Assign(Value);
end;

//--------          ----------

procedure ThiStringTable.SetIListProp;
begin
   IList.BkColor:= _prop_IconColColor;
   IList.ImgWidth:= _prop_ImgSize;
   IList.ImgHeight:= _prop_ImgSize;
end;

//-------------------         ---------------------

procedure ThiStringTable._var_IconArray;
begin
  if Assigned(Ilist) then
     begin
        if not Assigned(ICArray) then ICArray := CreateArray(_SetIcon,_GetIcon,_CountIcon,_AddIcon);
        dtArray(_Data,ICArray);
     end
  else dtArray(_Data,nil);
end;

procedure ThiStringTable._SetIcon(var Item:TData; var Val:TData);
var   ind:integer;
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) and _IsIcon(Val) then
      IList.ReplaceIcon(ind, ToIcon(val).handle);
   Control.Invalidate;
end;

function ThiStringTable._GetIcon(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   Result:= False;
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) then begin
      Icon.Clear;
      Icon.Handle:= IList.ExtractIcon(ind);
      dtIcon(Val,Icon);
      Result:= True;
   end;
end;

function ThiStringTable._CountIcon:integer;
begin
   Result:=0;
   if not Assigned(Ilist) then Exit;
   Result:= IList.Count;
end;

procedure ThiStringTable._AddIcon(var Val:TData);
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   if _IsIcon(Val) then IList.AddIcon(ToIcon(Val).Handle);
   Control.Invalidate;
end;

//-----------------        ---------------------

procedure ThiStringTable._work_doDeleteIcon;
var   ind:integer;
begin
   ind:= ToInteger(_Data);
   if not (Assigned(IList) and (ind >= 0) and (ind < IList.Count)) then Exit;
   IList.Delete(ind);
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeImgLst);
end;

procedure ThiStringTable._work_doGetIcon;
var   dt,di:TData;
      bmp:PBitmap;
begin
   dtNull(di);
   bmp:= nil;
   Icon.Clear;
   if Assigned(IList) and (Ilist.Count <> 0) then
      if _GetIcon(_Data,dt) then Icon{$ifndef F_P}^{$endif} := ToIcon(dt){$ifndef F_P}^{$endif} ;
   if Icon.Handle <> 0 then
      if _prop_IconToBmp then begin
         bmp:= NewDIBBitmap(Icon.Size,Icon.Size,pf32bit);
         bmp.Handle:= Icon.Convert2Bitmap(_prop_Transparent);
         dtBitmap(di,bmp);
      end
      else dtIcon(di,Icon);
   _hi_onEvent(_event_onGetIcon,di);
   If Assigned(bmp) then bmp.free;
end;

procedure ThiStringTable._work_doGetIconIdx;
var   idx,ind:integer;
begin
   ind:= ToInteger(_Data);
   idx:= -1;
   if Assigned(IList)and(Ilist.Count <> 0)and(Control.Count<>0) then
      idx:= Control.LVItemImageIndex[ind]; 
   _hi_CreateEvent(_Data,@_event_onGetIconIdx,idx);
end;

procedure ThiStringTable.InsertIcon;
var   dt:TData;
      i,ind:integer;
begin
   dt:= Data;
   ind:= integer(Index);
   if not (Assigned(IList)and _IsIcon(dt)and(ind >= 0)and(ind < IList.Count)) then exit;
   i:= IList.Count - 1;
   IList.AddIcon(IList.ExtractIcon(i));
   repeat
      IList.ReplaceIcon(i,IList.ExtractIcon(i-1));
      dec(i);            
   until i <= ind;
   IList.ReplaceIcon(ind, ToIcon(dt).handle);
   SetColumns(CList,1);
end;

procedure ThiStringTable._work_doClearIcons;
begin
   ClearIcons;
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeImgLst);
end;

procedure ThiStringTable.ClearIcons;
begin
   if (not Assigned(IList)) or (Ilist.Count = 0) then Exit;
   repeat
     IList.Delete(Ilist.Count - 1);
   until Ilist.Count = 0;
   Control.Invalidate;
end;

//--------------        -----------------

Procedure ThiStringTable._work_doGetMiscIcon;
var   ind:integer;
      bmp:PBitmap;
      di:TData;
begin
   dtNull(di);
   bmp:= nil;
   ind:= ToInteger(_Data);
   if ind > IDList.Count - 1 then exit;
   Icon.Clear;
   Icon.Handle:= IDList.Objects[ind];
   if Icon.Handle <> 0 then
      if _prop_IconToBmp then
         begin
            bmp:= NewDIBBitmap(Icon.Size,Icon.Size,pf32bit);
            bmp.Handle:= Icon.Convert2Bitmap(_prop_Transparent);
            dtBitmap(di,bmp);
         end
      else dtIcon(di,Icon);
   _hi_onEvent(_event_onGetMiscIcon,di);
   If Assigned(bmp) then bmp.free;
end;

//----------------         -------------------

procedure ThiStringTable._work_doLoadPakIcons;
var   i,IconCount:integer;
      fn:string;
begin
   if not Assigned(IList) then exit;
   fn:= ReadString(_Data,_data_IconsFileName,_prop_IconsFileName);
   if not LFileExists_MT(fn,LOAD_PAK_ICONS) then Exit;
   Icon.Clear;
   IconCount:= GetFileIconCount(fn);
   if IconCount <> 0 then begin
      ClearIcons;
      i:= 0;
      repeat
         Icon.LoadFromExecutable(fn,i);
         SetIListProp;
         IList.AddIcon(Icon.Handle);
         inc(i);
      until i = IconCount;
   end;
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeImgLst);
end;

procedure ThiStringTable._work_doLoadIcon;
var   ind:integer;
      fn:string;
      dt:TData;
begin
   if not Assigned(IList) then exit;
   ind:=Tointeger(_Data);
   fn:= ReadString(_Data,_data_IconFileName,_prop_IconFileName);
   if not LFileExists_MT(fn,LOAD_ICON) then Exit;
   Icon.Clear;
   Icon.LoadFromFile(fn);
   dtIcon(dt,Icon);
   if (ind >= IList.Count) or (ind < 0) then _AddIcon(dt)
   else if (ind >= 0 ) and (ind < IList.Count ) then InsertIcon(dt,ind);
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeImgLst);
end;

procedure ThiStringTable._work_doSaveIcon;
var   dt,di:TData;
      fn:string;
      Pos:Integer;
      Bitmaps:array of HBitmap;
      II:TIconInfo;
      Strm, st:PStream;
begin
   if not Assigned(IList) then exit;
   di:= _Data;
   fn:= ReadString(_Data,_data_IconFileName,_prop_IconFileName);
   if SFileExists_MT(fn,SAVE_ICON_FILE) then Exit;
   Icon.Clear;
   if _GetIcon(di,dt) then Icon{$ifndef F_P}^{$endif} := ToIcon(dt){$ifndef F_P}^{$endif} ;
   st:= NewWriteFileStream(fn);
   Strm:= NewMemoryStream;
   Pos:= Strm.Position;
   SetLength(Bitmaps, 2);
   GetIconInfo(Icon.Handle,II);
   Bitmaps[0]:= II.hbmColor;
   Bitmaps[1]:= II.hbmMask;
   if not SaveIcons2StreamEx(Bitmaps,Strm) then Strm.Seek(Pos,spBegin);
   Strm.Position:= 0;
   Stream2Stream(st,Strm,Strm.Size);
   st.free;
   Strm.free;
end;

//-------------------        ---------------------

procedure ThiStringTable._work_doSaveIList;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_IListFileName,_prop_IListFileName);
   if SFileExists_MT(fn,SAVE_ILIST) then Exit;
   SaveIListToFile(fn,Index);
end;

procedure ThiStringTable.SaveIListToFile;
var   Strm, st:PStream;
      i,Pos:Integer;
      Bitmaps:array of HBitmap;
      II:TIconInfo;
      Bmp:HBitmap;
begin
   if not Assigned(Ilist) then Exit;
   for I:= 0 to IList.Count - 1 do if IList.ExtractIcon(I) = 0 then Exit;
   Strm:= NewMemoryStream;
   Pos:= Strm.Position;
   SetLength(Bitmaps, IList.Count * 2);
   for I:= 0 to IList.Count - 1 do begin
      GetIconInfo(IList.ExtractIcon(I),II);
      Bitmaps[I * 2]:= II.hbmColor;
      Bitmaps[I * 2 + 1]:= II.hbmMask;
   end;
   if not SaveIcons2StreamEx(Bitmaps,Strm) then Strm.Seek(Pos,spBegin);
   for i:= 0 to High(Bitmaps) do begin
      Bmp:= Bitmaps[i];
      if Bmp <> 0 then DeleteObject(Bmp);
   end;
   If Index <> 0 then begin
      st:= NewWriteFileStream(FileName);
      Strm.Position:= 0;
      Stream2Stream(st,Strm,Strm.Size);
      st.free;
   end
   else begin
      Strm.Position:= 0;
      Stream2Stream(SICLStream,Strm,Strm.Size);
   end;
   Strm.free;
end;

//-------------------        ----------------------

procedure ThiStringTable._work_doLoadIList;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_IListFileName,_prop_IListFileName);
   if not LFileExists_MT(fn,LOAD_PAK_ICONS) then Exit;
   LoadIListFromFile(fn,1);
   SetColumns(CList,1);
end;

procedure ThiStringTable.LoadIListFromFile(const FileName: String; Index: word);
var   Strm, st: PStream;
      Pos: DWord;
      Data: TStreamData;

   function ReadIcon : Boolean;
   var   IDI, FoundIDI : TIconDirEntry;
         I, j: Integer;
         II : TIconInfo;
         BIH : TBitmapInfoheader;
         IH : TIconHeader;
         Mem: PStream;
         ImgBmp, MskBmp : PBitmap;
   begin
      ImgBmp:= nil;
      MskBmp:= nil;
      Result:= False;
      if Strm.Read(IH, Sizeof(IH)) <> Sizeof(IH) then Exit;
      if (IH.idReserved <> 0) or ((IH.idType <> 1) and (IH.idType <> 2)) or
         (IH.idCount < 1) then exit;
      for j:= 1 to IH.idCount do begin
         if Strm.Read(IDI, Sizeof(IDI)) <> Sizeof(IDI) then Exit;
         if (IDI.bWidth <> IDI.bHeight) and (IDI.bWidth * 2 <> IDI.bHeight) or 
            (IDI.bWidth = 0) then exit;
         FoundIDI:= IDI;
         Strm.Seek(Integer(Pos) + (FoundIDI.dwImageOffset), spBegin);
         Data.fSize:= FoundIDI.bWidth;
         if Strm.Read(BIH, Sizeof(BIH)) <> Sizeof(BIH) then Exit;
         if (BIH.biWidth <> integer(Data.fSize)) or (BIH.biHeight <> integer(Data.fSize) * 2) and
            (BIH.biHeight <> integer(Data.fSize)) then exit;
         BIH.biHeight:= Data.fSize;
         Mem:= NewMemoryStream;
      TRY
         Mem.Write(BIH, Sizeof(BIH));
         if (FoundIDI.bColorCount >= 2) or (FoundIDI.bReserved = 1) or (FoundIDI.bColorCount = 0) then begin
            I:= 0;
            if BIH.biBitCount <= 8 then I := (1 shl BIH.biBitCount) * Sizeof(TRGBQuad);
            if I > 0 then if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
            I:= ((BIH.biBitCount * Data.fSize + 31) div 32) * 4 * Data.fSize;
            if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
            ImgBmp:= NewDIBBitmap(Data.fSize, Data.fSize,pf32bit);
            Mem.Seek(0, spBegin);
            ImgBmp.LoadFromStream(Mem);
            if ImgBmp.Empty then exit;
         end;
         BIH.biBitCount:= 1;
         Mem.Seek(0, spBegin);
         Mem.Write(BIH, Sizeof(BIH));
         I:= 0;
         Mem.Write(I, Sizeof(I));
         I:= $FFFFFF;
         Mem.Write(I, Sizeof(I));
         I:= ((Data.fSize + 31) div 32) * 4 * Data.fSize;
         if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
         MskBmp:= NewDIBBitmap(Data.fSize,Data.fSize,pf32bit);
         Mem.Seek(0, spBegin);
         MskBmp.LoadFromStream(Mem);
         if MskBmp.Empty then exit;
         FillChar(II, Sizeof(II), 0);
         II.fIcon:= True;
         II.xHotspot:= 0;
         II.yHotspot:= 0;
         II.hbmMask:= MskBmp.ReleaseHandle;
         II.hbmColor:= ImgBmp.ReleaseHandle;
         Data.fHandle:= CreateIconIndirect(II);
         SetIListProp;
         IList.AddIcon(Data.fHandle);
         DestroyIcon(Data.fHandle);
         DeleteObject(II.hbmMask);
         DeleteObject(II.hbmColor);         
         Strm.Seek(integer(Pos) + Sizeof(IH) +  Sizeof(IDI)*j, spBegin);
      FINALLY
         if Assigned(ImgBmp) then ImgBmp.free;
         if Assigned(MskBmp) then MskBmp.free;
         Mem.free;      
      END;
      end;
      Result:= Data.fHandle <> 0;
   end;

begin
   Strm:= NewMemoryStream;
   if ((Index = 0) and not Assigned(LICLStream)) or not Assigned(IList) then exit;
   if ((Index = 0) and (LICLStream.Size = 0)) then exit; 
   if (Index = 0) then begin
     LICLStream.Position:= 0;
     Stream2Stream(Strm,LICLStream,LICLStream.Size);
   end
   else begin
      st:= NewReadFileStream(Filename);
      Stream2Stream(Strm,st,st.Size);
      st.free;
   end;
   ClearIcons;
   Strm.Position:= 0;
   Data:= Strm.Data;
   Pos:= Data.fPosition;
   ReadIcon;
   Strm.free;
   Control.Invalidate;
   _hi_onEvent(_event_onChangeImgLst);
end;

//------------------        ---------------------

procedure ThiStringTable._var_CountIcons;
begin
   dtInteger(_Data,IList.Count);
end;

procedure ThiStringTable._var_EndIdxIcons;
begin
   if IList.Count = 0 then dtNull(_Data) 
   else dtInteger(_Data,IList.Count - 1);
end;

//#####################################################################
//#                                                                   #
//#                                              #
//#                                                                   #
//#####################################################################

//--------------         --------------

function ThiStringTable.LFileExists_MT;
var dt1,dt2:TData;
begin
   Result:= True;
   if FileExists(FileName) then Exit;
   dtInteger(dt1, FileOperation);
   dtString(dt2, FileName);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_LFileExists_MT);
   Result:=False;
end;

//--------------         --------------

function ThiStringTable.SFileExists_MT;
var dt1,dt2:TData;
begin
   Result:= False;
   if not FileExists(FileName) then Exit;
   dtInteger(dt1, FileOperation);
   dtString(dt2, FileName);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_SFileExists_MT); 
   if ToInteger(dt1) <> 0 then Result:= True;
end;

//---------------        ---------------

procedure ThiStringTable._work_doEndEdit;
begin
   if not _prop_Redaction then Exit;
   if  ReadInteger(_Data,_data_EndEdit,0) = 0 then
      Control.Perform(WM_KEYDOWN,27,0)
   else
      Control.Perform(WM_JUSTFREE,0,0);
end;

procedure ThiStringTable._work_doStartEdit;
begin
   if not _prop_Redaction then Exit;
      Control.Perform(WM_DBLCLICK,0,0);
end;

//#####################################################################
//#                                                                   #
//#                    /                     #
//#                                                                   #
//#####################################################################

//----------------------       -----------------------

procedure ThiStringTable._work_doSave;
var   i,j,p:integer;
      lst:PStrList;
      str,fn,s,sa,sb:string;
      Count:dword;
begin
   lst:= NewStrList;
   lst.Add('');
   FTblStream.free;
   FTblStream:= NewMemoryStream;
   STblStream:= NewMemoryStream;
   SIClStream:= NewMemoryStream;
TRY
   if Index <> 0 then begin
      fn:= ReadString(_Data,_data_FileName,_prop_FileName);
      if SFileExists_MT(fn,SAVE_TABLE) then Exit;
   end;
   if not _prop_SaveWidth then
      str:= CList.text
   else begin
      for i:= 0 to CList.Count - 1 do begin
         s:= CList.Items[i];
         sa:= GetTok(s,'=');
         sb:= GetTok(s,'=');
         sb:= int2str(Control.LVColWidth[i]);
         CList.Items[i]:= sa + '=' + sb + '=' + s; 
      end;
      str:= CList.text;
   end;
   Replace(str,#13#10,_StrDlm);
   if not _prop_StaticColumn then begin
      if _prop_SaveColProp then
         if _prop_SaveColor then
            lst.Items[0]:= int2str(Color2RGB(_prop_TextColor)) + _ColorDlm + int2str(Color2RGB(_prop_TextBkColor)) + _ColorDlm + int2str(Color2RGB(_prop_BkColor)) + _ColorDlm + int2str(Color2RGB(_prop_Transparent)) + _ColorDlm + str
         else lst.Items[0]:= str
      else begin
         for i:= 0 to Control.LVColCount - 1 do
            if i = 0 then lst.Items[0]:= Control.LVColText[i]
            else lst.Items[0]:= lst.Items[0] + _StrDlm + Control.LVColText[i];
      end;
      p:= 1;
      end
   else p:= 0;
   if (Control.Count > 0)and(Control.LVColCount > 0) then
      for i:= 0 to Control.Count - 1 do begin
         lst.Add('');
         for j:= 0 to Control.LVColCount - 1 do
            if j = 0 then begin
               lst.Items[i+p]:= '';
               if _prop_SaveImgIndex then lst.Items[i+p]:= int2str(Control.LVItemImageIndex[i]) + _StrDlm;
               if _prop_SaveItemsColor then lst.Items[i+p]:= lst.Items[i+p] + PakColor2Str(Control.LVItemData[i]) + _StrDlm;         
               lst.Items[i+p]:= lst.Items[i+p] + Control.LVItems[i,j];
            end
            else lst.Items[i+p]:= lst.Items[i+p] + _StrDlm + Control.LVItems[i,j];
      end;
   if p = 0 then lst.Delete(Control.Count);
   if Index = 0 then
      lst.SaveToStream(STblStream)
   else
      lst.SaveToFile(fn);
   if Index <> 0 then Exit;
   SaveIListToFile('',0);
   STblStream.Position:= 0;
   SICLStream.Position:= 0;
   Count:= STblStream.Size; 
   FTblStream.Write(Count,4);
   Stream2Stream(FTblStream,STblStream,STblStream.Size);
   Count:= SICLStream.Size;
   FTblStream.Write(Count,4);
   Stream2Stream(FTblStream,SICLStream,SICLStream.Size);   
FINALLY
   lst.free;
   STblStream.free;
   SICLStream.free;
END;
end;

//-----------------------       ------------------------

procedure ThiStringTable._work_doLoad;
var   i,p:integer;
      lst:PStrList;
      s,sa,tc,tbc,bc,tr,fn:string;
      dt:TData;
      Count:dword;
begin
   if Index = 0 then begin
      dtNull(dt);
      LoadStream:= ReadStream(dt,_data_FTblStream,nil);
      if LoadStream = nil then exit; 
      LTblStream:= NewMemoryStream;
      LICLStream:= NewMemoryStream; 
      LoadStream.Position:= 0;
      LoadStream.Read(Count,4);
      Stream2Stream(LTblStream,LoadStream,Count);
      LoadStream.Read(Count,4);               
      Stream2Stream(LICLStream,LoadStream,Count);
      if LICLStream.Size <> 0 then LoadIListFromFile('',0);
      if LTblStream.Size = 0 then exit;
      LTblStream.Position:= 0;
      lst:= NewStrList;
      lst.LoadFromStream(LTblStream,False);
      LICLStream.free;
      LTblStream.free;
   end
   else begin
      fn:= ReadString(_Data,_data_FileName,_prop_FileName);
      if not LFileExists_MT(fn,LOAD_TABLE) then Exit; 
      lst:= NewStrList;
      lst.LoadFromFile(fn);
   end;
   Control.Clear;
   if not _prop_StaticColumn then begin
      while Control.LVColCount > 0 do Control.LVColDelete(0);
      if lst.Count > 0 then begin
         sa:= lst.Items[0];
         s := sa + _ColorDlm;
         tc:= gettok(s,_ColorDlm);
         tbc:=gettok(s,_ColorDlm);
         if (tc <> '') and (tbc ='') then begin
            tc:= ''; bc:= ''; tr:= ''; s:= sa;
         end
         else begin
            bc:= gettok(s,_ColorDlm);
            tr:= gettok(s,_ColorDlm);
            if (tc <> '') and (tbc <> '') and (bc <> '') and (tr <> '') then begin
               dtString(dt,tc); _work_doTextColor(dt,0);
               dtString(dt,tbc); _work_doTextBkColor(dt,0);
               dtString(dt,bc); _work_doBkColor(dt,0);
               dtString(dt,tr); _work_doTransparent(dt,0);
            end;
         end;         
         Replace(s,_ColorDlm,'');
         Replace(s,_StrDlm,#13#10);
         CList.text:= s;
         SetColumns(CList,0);
      end;
      p:= 1;
   end else p:= 0;
   if lst.Count > 0 then begin
      for i:= p to lst.Count - 1 do Add(lst.Items[i]);
      Control.Invalidate;
   end;
   lst.free;
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doSaveFStream;
begin
   _work_doSave(_Data,0);
end;

procedure ThiStringTable._work_doLoadFStream;
begin
   _work_doLoad(_Data,0);
end;

procedure ThiStringTable._var_FStream;
begin
   if not Assigned(FTblStream) then exit; 
   dtNull(_Data);
   dtStream(_Data,FTblStream);
end;

//---------------------       ----------------------

procedure ThiStringTable.SetTextStrLst;
begin
   FList:= NewStrList;
   Flist.Text:= Value;
end;

procedure ThiStringTable._work_doAddStrLst;
begin
   FList.Add(ReadString(_Data,_data_StrLst,''));
   _hi_onEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doTblStrLst;
var   ind:integer;
begin
   if not _prop_AppTxtStrLst then Control.Clear;
   for ind:= 0 to FList.Count - 1 do Add(FList.Items[ind]);
   _hi_onEvent(_event_onChange);
end;

procedure ThiStringTable._work_doGetStrList;
var   ind:integer;
      s:string;
begin
   ind := ToIntIndex(_Data);
   s:= '';
   if(ind >= 0)and(ind < FList.Count)then s:= FList.Items[ind];
   _hi_onEvent(_event_onGetStrList,s);
end;

procedure ThiStringTable._work_doClearStrLst;
begin
   FList.Clear;
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doDeleteStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if not ((ind >= 0)and(ind < FList.Count)) then exit;
   FList.Delete(ind);
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doLoadStrLst;
var   fn:string;
      Strm:PStream;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if not LFileExists_MT(fn,LOAD_STRING_LIST) then Exit;
   Strm:= NewReadFileStream(fn);
   Strm.Position:= 0;
   FList.LoadFromStream(Strm, false);
   Strm.free;
   _hi_onEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doSaveStrLst;
var   fn:string;
      Strm:PStream;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if SFileExists_MT(fn,SAVE_STRING_LIST) then Exit;
   Strm:= NewWriteFileStream(fn);
   Strm.Position:= 0;
   FList.SaveToStream(Strm);
   Strm.free;
end;

procedure ThiStringTable._work_doAppendStrFile;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if SFileExists_MT(fn,APPEND_STRING_FILE) then Exit;
   FList.AppendToFile(fn);
end;

procedure ThiStringTable._work_doInsertStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if not ((ind >= 0) and (ind < FList.Count)) then Exit;
   FList.Insert(ind, ReadString(_Data,_data_StrLst,''));
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doTextStrLst;
begin
   FList.Text:= ReadString(_Data,_data_StrLst,'');
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doAddTextStrLst;
begin
   FList.Text:= FList.Text + ReadString(_Data,_data_StrLst,'');
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._work_doSortStrLst;
begin
   FList.Sort(false);
   _hi_OnEvent(_event_onChangeStrLst);
end;

procedure ThiStringTable._var_CountStrLst;
begin
   dtInteger(_Data,FList.Count);
end;

procedure ThiStringTable._var_EndIdxStrLst;
begin
   if FList.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,FList.Count - 1);
end;

procedure ThiStringTable._var_TextStrLst;
begin
   dtString(_Data,FList.Text);     
end;

procedure ThiStringTable._var_StrLstArray;
begin
   if SLArray = nil then
      SLArray:= CreateArray(_SetStrLst, _GetStrLst, _CountStrLst, _AddStrLst);
   dtArray(_Data,SLArray);
end;

procedure ThiStringTable._SetStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < FList.Count)then
      FList.Items[ind]:= ToString(Val);
end;

function ThiStringTable._GetStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < FList.Count)then begin
      Result:= true;
      dtString(Val,FList.Items[ind]);
   end
   else Result:= false;
end;

function ThiStringTable._CountStrLst;
begin
   Result:= FList.Count;
end;

procedure ThiStringTable._AddStrLst;
begin
   FList.Add(ToString(val));
end;

//#####################################################################
//#                                                                   #
//#                      ComboBox'                        #
//#                                                                   #
//#####################################################################

procedure ThiStringTable._work_doEnableCombo;
begin
   if not Assigned(ComboBox) then Exit;
   if boolean(ToInteger(_Data)) then begin
      _prop_ComboBox:= True; 
      ComboBox.Color:= Control.Color;
      if _prop_ComboTextColor then ComboBox.Font.Color:= _prop_TextColor;
   end
   else begin
      _prop_ComboBox:= False;
      ComboBox.Visible:= False;
   end;
   _FlagCombo:= _prop_ComboBox and not _prop_Redaction;
   if _prop_TypeComboInit = 2 then _work_doComboInit(_Data,Index);
end;

procedure ThiStringTable._work_doComboColumn;
var   idx:integer;
begin
   if not Assigned(ComboBox) or not _FlagCombo then Exit;
   idx:= ToInteger(_Data);
   if idx < 0 then exit
   else if idx > Clist.Count - 1 then idx:= Clist.Count - 1;   
   ComboCol:= idx;
   ComboBox.Visible:= False;
   Control.LVCurItem:= -1;
   ComboBox.CurIndex:= -1;
   ComboBox.Perform(WM_KEYDOWN,27,0);
   Control.LVCurItem:= ComboItem;
   if _prop_TypeComboInit = 2 then _work_doComboInit(_Data,Index);
   ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(Control.LVItems[ComboItem,ComboCol])));
end;

procedure ThiStringTable._work_doComboInit;
var   d:PData;
      idx:integer;
      s:string;
begin
   if not Assigned(ComboBox) then Exit;
   ComboBox.Clear;
   case _prop_TypeComboInit of
      0: if not _prop_AutoTblStrLst then
            for idx := 0 to min((FList.Count - 1), (_prop_MaxComboItem - 1)) do
               ComboBox.Add(FList.Items[idx]);  
      1: begin
            d := @_Data;
            idx:= 0;
            while (d <> nil) and not _IsNULL(d^) and
               (ComboBox.Count < _prop_MaxComboItem) do begin
                  ComboBox.Items[idx]:= ToString(d^);
                  inc(idx);
                  d := d.ldata;
            end;
            if (d <> nil) and not _IsNULL(d^) then FreeData(d);
      end;
      2: begin
            idx:= 0;
            while (idx < Control.Count) and (ComboBox.Count < _prop_MaxComboItem) do begin
               s:= Control.LVItems[idx, ComboCol]; 
               if ComboBox.Insert(0,'') = -1 then ComboBox.Add('');
               ComboBox.CurIndex:= 0;
               ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
               if ComboBox.CurIndex > 0 then
                  ComboBox.Delete(0)
               else begin
                  ComboBox.Delete(0);
                  ComboBox.Add(s);
               end;   
               inc(idx);
            end;
         end;
   end;      
   ComboBox.Color:= Control.Color;
   if _prop_ComboTextColor then ComboBox.Font.Color:= _prop_TextColor;
end;

//#####################################################################
//#                                                                   #
//#                           MT-                               #
//#                                                                   #
//#####################################################################

procedure ThiStringTable.MT_ActionItm;
var   Row,Col,ico:integer;
      ss:string;
      DColor:dword;
      d:PData;
begin
   d := @Data;
TRY
   Row:= Control.Count;
   if (Mode = ITM_INSERT) or (Mode = ITM_REPLACE) then
      if (d <> nil) and not _IsNULL(d^) then begin
         Row:= ToInteger(d^);   
         d:= d.ldata;
         if (Row > Control.Count - 1) then exit;
      end;
   Col:= 0;
   ico:= I_SKIP;
   DColor:= 0;
   if Assigned(Ilist) and (d <> nil) and not _IsNULL(d^) then begin
      ico:= ToInteger(d^);
      if ico > IList.Count - 1 then ico:= I_SKIP;
      d := d.ldata;      
   end;
   if _prop_ColorItems and (d <> nil) and not _IsNULL(d^) then begin
      ss:= ToString(d^) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) and not (Row < 0) then begin
      if Mode = ITM_ADD then
         Control.LVItemAdd('')
      else if (Mode = ITM_INSERT) and (Row < Control.Count) then
         Control.LVItemInsert(Row,'');     
      while (d <> nil) and not _IsNULL(d^) and (Row < Control.Count) do begin
         Control.LVSetItem(Row,Col,ToString(d^),ico,[],I_SKIP,I_SKIP,DColor);
         inc(Col);
         d := d.ldata;
      end;
      _hi_onEvent(_event_onChange);
   end;
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable.MT_ActionCol;
var   s:string;
      ind:integer;
      d:PData;
begin
   d := @Data;
TRY
   ind:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      ind:=ToInteger(d^);   
      d:= d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      s:=ToString(d^);   
      d:= d.ldata;
   end;
   if (Mode = ITM_INSERT) and (ind >= 0) then begin
      if (ind > CList.Count - 1) then begin
         Control.LVColAdd('',_prop_TextAlign,_prop_ColumnWidth);
         CList.Add(InitColStr(s));
      end
      else begin
         Control.LVColInsert(ind,'',_prop_TextAlign,_prop_ColumnWidth);
         CList.Insert(ind,InitColStr(s));
      end;
   end
   else if (Mode = ITM_REPLACE) and not ((ind < 0)or(ind > CList.Count - 1)) then
      CList.Items[ind]:= InitColStr(s)
   else exit;
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeColLst);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable.MT_ActionIco;
var   idx:integer;
      di:TData;
      d:PData;
begin
   d := @Data;
TRY
   idx:= I_SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      di:= d^;
      d := d.ldata;   
   end;
   if not _IsIcon(di) or not Assigned(Ilist) or (idx < 0) then exit;
   if (Mode = ITM_INSERT) and (idx > IList.Count - 1) then
      _AddIcon(di)
   else if (Mode = ITM_INSERT) and (idx < IList.Count) then 
      InsertIcon(di,idx)
   else if (Mode = ITM_REPLACE) and (idx < IList.Count) then
      IList.ReplaceIcon(idx, ToIcon(di).handle)
   else exit;
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeImgLst);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable.MT_ProperCol;
var   s,name,width,imgidx,aligntxt:string;
      ind:integer;
      d:PData;
begin
   d := @Data;
TRY
   ind:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      ind:=ToInteger(d^);   
      d:= d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      s:=ToString(d^);   
      d:= d.ldata;
   end;
   if (ind < 0) or (ind > CList.Count - 1) then exit;
   name:= Control.LVColText[ind];
   width:= int2str(Control.LVColWidth[ind]);
   imgidx:=int2str(Control.LVColImage[ind]);
   aligntxt:=int2str(integer(Control.LVColAlign[ind]));  
   if Mode = COL_NAME then name:= s
   else if Mode = COL_WIDTH then width:= s
   else if Mode = COL_IMAGE then imgidx:= s
   else if Mode = COL_ALIGN then aligntxt:= s
   else exit;   
   s:= name + '=' + width + '=' + imgidx + '=' + aligntxt;
   CList.Items[ind]:= InitColStr(s);
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeColLst);   
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable.MT_EMatrix;
var   x,y:integer;
      dt:TData;
      d:PData;
begin
   d := @Data;
TRY
   x:= SKIP; y:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      x:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      y:= ToInteger(d^);
      d := d.ldata;   
   end;
   if (x >= 0) and (y >= 0) then begin
      if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
         ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
         (Mode = EMATRIX) then begin
            dt:= MX_Get(x,y);
            AddMTData(@Data,@dt,d); 
      end;
   end
   else if (x < 0) and (y >= 0) then begin
      for x:= 0 to Control.LVColCount - 1 do
         if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
            ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
            (Mode = EMATRIX) then begin              
               dt:= MX_Get(x,y);
               AddMTData(@Data,@dt,d); 
         end;
   end
   else if (x >= 0) and (y < 0) then begin
      for y:= 0 to Control.Count - 1 do
         if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
            ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
            (Mode = EMATRIX) then begin
                dt:= MX_Get(x,y);
               AddMTData(@Data,@dt,d); 
         end;
   end;
   _hi_onEvent_(_event_onMT_EMatrix,Data);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doMT_Add;begin MT_ActionItm(_Data, ITM_ADD);end;
procedure ThiStringTable._work_doMT_Insert;begin MT_ActionItm(_Data, ITM_INSERT);end;
procedure ThiStringTable._work_doMT_Replace;begin MT_ActionItm(_Data, ITM_REPLACE);end;
procedure ThiStringTable._work_doMT_InsertCol;begin MT_ActionCol(_Data, ITM_INSERT);end;
procedure ThiStringTable._work_doMT_ReplaceCol;begin MT_ActionCol(_Data, ITM_REPLACE);end;
procedure ThiStringTable._work_doMT_ReplaceIcon;begin MT_ActionIco(_Data,ITM_REPLACE);end;
procedure ThiStringTable._work_doMT_InsertIcon;begin MT_ActionIco(_Data,ITM_INSERT);end;

procedure ThiStringTable._work_doMT_NameCol;begin MT_ProperCol(_Data, COL_NAME);end;
procedure ThiStringTable._work_doMT_WidthCol;begin MT_ProperCol(_Data, COL_WIDTH);end;
procedure ThiStringTable._work_doMT_ImageCol;begin MT_ProperCol(_Data, COL_IMAGE);end;
procedure ThiStringTable._work_doMT_AlignTxtCol;begin MT_ProperCol(_Data, COL_ALIGN);end;

procedure ThiStringTable._work_doMT_EMatrix;begin MT_EMatrix(_Data,EMATRIX);end;
procedure ThiStringTable._work_doMT_ChkEMatrix;begin MT_EMatrix(_Data,CHK_EMATRIX);end;
procedure ThiStringTable._work_doMT_SelEMatrix;begin MT_EMatrix(_Data,SEL_EMATRIX);end;

procedure ThiStringTable._work_doMT_AddCols;
var   s:string;
      d:PData;
begin
   d := @_data;
TRY
   if not _prop_AllMT_AddCol and Assigned(IList) and (d <> nil) and not _IsNULL(d^) then d:= d.ldata;
   if not _prop_AllMT_AddCol and _prop_ColorItems  and (d <> nil) and not _IsNULL(d^) then d:= d.ldata;
   while (d <> nil) and not _IsNULL(d^) do begin
      s:= ToString(d^);
      d := d.ldata;
      Replace(s, _MTColDlm, '=');
      Control.LVColAdd('',_prop_TextAlign,_prop_ColumnWidth);
      CList.Add(InitColStr(s));
   end; 
   SetColumns(CList,1);
   _hi_onEvent(_event_onChangeColLst);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doMT_CheckBox;
var   idx,val:integer;
      d:PData;
begin
   d := @_data;
TRY
   idx:= SKIP; val:= 0;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      val:= ToInteger(d^);
      d := d.ldata;   
   end;
   if (idx>=0)and(idx<Control.Count) then Control.LVItemStateImgIdx[idx]:= val;

FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doMT_IconStr;
var   idx,newico:integer;
      d:PData;
begin
   d := @_data;
TRY
   idx:= SKIP; newico:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      newico:= ToInteger(d^);
      d := d.ldata;   
   end;
   if Assigned(IList)and(idx>=0)and(idx<Control.Count)and(newico<IList.Count) then
      Control.LVItemImageIndex[idx]:= newico;
   SetColumns(CList,1);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doMT_IconCol;
var   idx,newico:integer;
      d:PData;
      ta:TTextAlign;
begin
   d := @_data;
TRY
   idx:= SKIP; newico:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      newico:= ToInteger(d^);
      d := d.ldata;   
   end;
   ta:= Control.LVColAlign[idx];
   if Assigned(IList)and(idx>=0)and(idx<Control.Count)and(newico<IList.Count)and(_prop_ImgColumn) then
      Control.LVColImage[idx]:= newico;
   Control.LVColAlign[idx]:= ta;
   Control.Invalidate;
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doMT_ColorsStr;
var   idx,idxcolortxt,colorback:integer;
      d:PData;
begin
   d := @_data;
TRY
   idx:= SKIP;
   idxcolortxt:= SKIP;
   colorback:= SKIP;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      idxcolortxt:= ToInteger(d^);
      d := d.ldata;   
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      colorback:= ToInteger(d^);
      d := d.ldata;   
   end;
   if (idx < 0) or (idx > Control.Count - 1) or not _prop_ColorItems then exit; 
   if (idxcolortxt >= 0) and (idxcolortxt <= 15) then begin 
      Control.LVItemData[idx]:= $00FFFFFF and Control.LVItemData[idx];
      Control.LVItemData[idx]:= dword(idxcolortxt shl 24) or Control.LVItemData[idx];
   end;
   if colorback >= 0 then begin
      Control.LVItemData[idx]:= $0F000000 and Control.LVItemData[idx];
      Control.LVItemData[idx]:= Control.LVItemData[idx] or dword(colorback);
   end;
   Control.Invalidate; 
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._var_GenColors_MT;
var   dt,di:TData;
      d:PData;
begin
TRY
   dtNull(di);
   dtInteger(dt,Color2RGB(_prop_BkColor));
   AddMTData(@di,@dt,d);
   dtInteger(dt,Color2RGB(_prop_TextColor));
   AddMTData(@di,@dt,d);
   dtInteger(dt,Color2RGB(_prop_TextBkColor));
   AddMTData(@di,@dt,d);
   dtInteger(dt,Color2RGB(_prop_Transparent));
   AddMTData(@di,@dt,d);
   CopyData(@_Data,@di);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._work_doGetColors_MT;
var   idx:integer;
      dt,di,dj,dk:TData;
      idxcolor:byte;
begin
   idx:= ToInteger(_Data);
   dtInteger(dt,idx);
   if (idx < 0) or (idx > Control.Count - 1) and _prop_ColorItems then exit; 
   idxcolor:= ($0F000000 and Control.LVItemData[idx]) shr 24;
   dtInteger(di,idxcolor);
   dt.ldata:= @di;
   if idxcolor = 0 then
      dtInteger(dj,Color2RGB(_prop_TextColor))  
   else
      dtInteger(dj,AColor[idxcolor]);
   di.ldata:= @dj;
   if $FFFFFF and Control.LVItemData[idx] = 0 then
      dtInteger(dk,Color2RGB(_prop_TextBkColor))
   else
      dtInteger(dk,$FFFFFF and Control.LVItemData[idx]);       
   dj.ldata:= @dk;
   _hi_onEvent_(_event_onMT_GetColors,dt);
end;

procedure ThiStringTable._work_doGetCol_MT;
var   ind:integer;
      dt,di,dj,dk,dl:TData;
begin
   ind:= ToInteger(_Data);
   if (ind < 0) or (ind > Control.LVColCount - 1) then exit;
   dtInteger(dt,ind);
   dtString(di,Control.LVColText[ind]);
   dt.ldata:= @di;
   dtInteger(dj,Control.LVColWidth[ind]);
   di.ldata:= @dj;
   dtInteger(dk,Control.LVColImage[ind]);
   dj.ldata:= @dk;
   dtInteger(dl,integer(Control.LVColAlign[ind]));
   dk.ldata:= @dl;
   _hi_onEvent_(_event_onMT_GetCol, dt);
end;

procedure ThiStringTable._var_AllSelect_MT;
var   i,j:integer;
      dt,di:TData;
      d:PData;
begin
TRY
   dtNull(di);
   i:= Control.LVCurItem;
   if Control.LVSelCount > 0 then begin
      repeat
         dtInteger(dt,i);
         AddMTData(@di,@dt,d); 
         j:= Control.LVNextSelected(i);
         i:= j;
      until j < 0;
   end;
   CopyData(@_Data,@di);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure ThiStringTable._var_AllCheck_MT;
var   i,j: word;
      dt,di:TData;
      d:PData;
begin
TRY
   dtNull(di);
   if Control.Count > 0 then begin
      for i:=0 to Control.Count - 1 do begin
         j:= Control.LVItemStateImgIdx[i];
         if j > 1 then 
            dtInteger(dt,i)
         else
            dtNull(dt); 
         AddMTData(@di,@dt,d);
      end;
   end;
   CopyData(@_Data,@di);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

//-----------------   MT-     -------------------

procedure ThiStringTable._work_doMT_LoadExtIcon;
var   ico: PIcon;
      fn:string;
      dt,di:TData;
      d:PData;
      idx:integer;
      bmp:PBitmap;
begin
   d:=@_Data;
   ico:= nil;
   bmp:= nil;
TRY
   dtNull(dt);
   fn:='';
   idx:= 0;
   if (d <> nil) and not _IsNULL(d^) then begin
      fn:= ToString(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      idx:= ToIntIndex(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      di:= d^;
      d := d.ldata;   
   end;
   if not LFileExists_MT(fn,LOAD_EXTICON) then Exit;
   ico:= NewIcon;
   if _prop_ImgSize < 24 then ico.handle:= GetSmallIcon(fn,idx)
                         else ico.LoadFromExecutable(fn,idx);
   if ico.Handle <> 0 then
      dtIcon(dt,ico)
   else if (_IsIcon(di)) and (ico.Handle = 0) then
      dtData(dt,di);
   if _prop_IconToBmp then begin
      bmp:= NewDIBBitmap(Ico.Size,Ico.Size,pf32bit);
      bmp.Handle:= Ico.Convert2Bitmap(_prop_Transparent);
      dtBitmap(dt,bmp);
   end;
   _hi_onEvent(_event_onExtIcon,dt);
FINALLY
   If Assigned(bmp) then bmp.free;
   if Assigned(ico) then ico.free;
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

//-----------------        -----------------

procedure ThiStringTable._work_doAutoColWidth;
var   Col,Row:integer;
      _Length, TempLength:integer;
      dt,di:TData;
begin
   if (Control.LVColCount <= 0) or (Control.Count <= 0) then exit;
   Col:= 0;
   repeat
      Row:= 0;
      _Length:= 0;
      repeat
         TempLength:= (Length(Control.LVItems[Row,Col]) + 1) * Control.Canvas.TextExtent('M').cx;
         _Length:= max(_Length,TempLength);
         inc(Row);                                                     
      until Row = Control.Count;
      _Length:= min(_Length,_prop_MaxColWidth);
      _Length:= max(_Length,_prop_MinColWidth);      
      dtInteger(dt,Col);
      dtInteger(di,_Length);
      dt.ldata:= @di;
      MT_ProperCol(dt, COL_WIDTH);
      inc(Col);
   until Col = Control.LVColCount;
end;

procedure ThiStringTable._work_doMaxColWidth;
begin
   _prop_MaxColWidth := ToInteger(_Data);
end;

procedure ThiStringTable._work_doSelectString;
var str, S2:string;
    Row,Col:integer;
    Data,dt:TData;
begin
   str:= ToString(_Data);
   Row:= 0; Col:= 0;
TRY
   repeat
      Col:= 0;
      repeat
         S2:= Control.LVItems[Row,Col];
         if AnsiCompareStrNoCase( str, S2 ) = 0 then begin
            Control.LVCurItem:= Row;
            exit;
         end;
         inc(Col);
      until Col = Control.LVColCount;   
      inc(Row);
   until Row = Control.Count;   
   Row:= -1;
   Col:= -1;
FINALLY
   dtInteger(Data,Row);
   dtInteger(dt,Col);
   Data.ldata:= @dt;
   _hi_onEvent_(_event_onMT_SelString,Data);
END;
end;

//----------------------------      ------------------------------
end.